package cn.axzo.msg.center.api.v2.message.resp;

import com.alibaba.fastjson.JSON;
import lombok.AllArgsConstructor;
import lombok.Data;
import lombok.NoArgsConstructor;

import java.io.Serializable;
import java.util.*;

/**
 * @author yanglin
 */
@Data
@AllArgsConstructor
@NoArgsConstructor
public class MessageSendV2Resp implements Serializable {
    /**
     * 这次批量发送的批次号, 如果配置了多个模版，多个渠道, 可以用批次号串联起来
     */
    private String batchNo;

    /**
     * 模版code -> 模版发送结果
     */
    private Map<String, TemplateSendV2Result> templateCode2SendResult;

    public void addResult(TemplateSendV2Result result) {
        templateCode2SendResult.put(result.getTemplateCode(), result);
    }

    public Optional<TemplateSendV2Result> findTemplateSendResult(String templateCode) {
        return Optional.ofNullable(templateCode2SendResult.get(templateCode));
    }

    public Set<String> templateCodes() {
        return new HashSet<>(templateCode2SendResult.keySet());
    }

    public Map<String, TemplateSendV2Result> templateSendResults() {
        return Collections.unmodifiableMap(templateCode2SendResult);
    }

    @Override
    public String toString() {
        return JSON.toJSONString(this);
    }
}